/* addfood.c */

/*
    NUT nutrition software 
    Copyright (C) 2004 Jim Jozwiak.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "addfood.h"
#include "food.h"
#include "meal.h"
#include "options.h"
#include "util.h"
#include "db.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

void add_foods(int label)
{
struct food *food_ptr = &food_root;
char key[121];
int c, delfood, junk, likeit = 'n', dupname = 0, resname = 0;
float ratio, one = 1, servings = 0, savegrams, savewater;
key[0] = '\0';
key_clean();
while (likeit == 'N' || likeit == 'n')
 {
 dupname = 0; resname = 0;
 if (! label) header("NUT:  Add a Recipe");
 if (label) header("NUT:  Add a Labeled Food");
 spacer(-1);
 if (! label) printf("Type name of new recipe (or <enter> to quit):  ");
 if (  label) printf("Type labeled food name (or <enter> to quit):  ");
 get_string(food_work.name,60);
 if (strcmp(food_work.name,"") == 0) return;
 junk = strlen(food_work.name);
 for (c = 0 ; c < junk ; c++) food_work.name[c] = toupper(food_work.name[c]);
 for (c = junk ; c >= 0 ; c--)
  {
  if (food_work.name[c] == ' ') food_work.name[c] = '\0';
  else break;
  }
 food_ptr = &food_root;
 while (food_ptr->next != NULL)
  {
  food_ptr = food_ptr->next;
  if (food_work.name[0] == food_ptr->name[0]) if (strcmp(food_work.name,food_ptr->name) == 0) dupname = 1;
  }
 if (strncmp(food_work.name,"THEUSUAL",8) == 0) resname = 1;
 if ( ! dupname || resname)
  {
  if (! label) header("NUT:  Add a Recipe");
  if (  label) header("NUT:  Add a Labeled Food");
  spacer(0);
  printf("Recipe name is \"%-s.\"\n",food_work.name);
  printf("Is this correct?  (y/n):  ");
  likeit = get_char();
  }
 if (dupname)
  {
  if (! label) header("NUT:  Add a Recipe");
  if (  label) header("NUT:  Add a Labeled Food");
  spacer(0);
  printf("\"%-s\"\n",food_work.name);
  printf("is a duplicate name.  Press <enter> to continue...");
  junk = get_char();
  likeit = 'n';
  }
 if (resname)
  {
  if (! label) header("NUT:  Add a Recipe");
  if (  label) header("NUT:  Add a Labeled Food");
  spacer(0);
  printf("\"%-s\"\n",food_work.name);
  printf("is a reserved name.  Press <enter> to continue...");
  junk = get_char();
  likeit = 'n';
  }
 }
if (strcmp(food_work.name,"") == 0) return;
if (  label)
 {
 header("NUT:  Add a Labeled Food");
 printf("\n\n\n    Now select the ingredients in the order they appear on the ingredients");
 printf("\n    statement.  Don't worry if you can't find some of the ingredients, but");
 printf("\n    for all of them that you do find, keep the order the same.");
 spacer(5);
 printf("\nPress <enter> to continue...");
 junk = get_int();
 }
for ( ; ; )
 {
 for ( ; ; )
  {
  if (recipe_root.next != NULL)
   {
   if (! label) header("NUT:  Add a Recipe");
   if (  label) header("NUT:  Add a Labeled Food");
   if (! recipe_show(0))
    {
    printf("\nPress <enter> to continue...");
    junk = get_int();
    }
   else
    {
    printf("\nEnter number to delete or food name (or <enter> to quit):  ");
    get_string(key,60);
    if (strcmp(key,"") == 0)
     {
     if (! label)
      {
      header("NUT:  Add a Recipe");
      recipe_show(0);
      printf("\nDo you want to save recipe in the food database?  (y/n):  ");
      junk = get_char();
      if (junk == 'n' || junk == 'N')
       {
       while (recipe_root.next != NULL) delete_recipe_food(1);
       return;
       }
      }
     junk = 'z';
     while (junk != 'Y' && junk != 'y' && junk != 'N' && junk != 'n')
      {
      if (! label) header("NUT:  Add a Recipe");
      if (  label) header("NUT:  Add a Labeled Food");
      recipe_show(0);
      if (! label) printf("\nDo you want to add more foods to recipe?  (y/n):  ");
      if (  label) printf("\nDo you want to add more ingredients?  (y/n):  ");
      junk = get_char();
      }
     if (junk == 'y' || junk == 'Y') continue;
     clear_work();
     if (label) add_labels();
     food_ptr = &recipe_root;
     while (food_ptr->next != NULL && ! label)
      {
      food_ptr = food_ptr->next;
      for (c = 0; c < NUTRIENT_COUNT; c++) food_work.nutrient[c] += (food_ptr->nutrient[c] * food_ptr->grams / 100); 
      food_work.grams += food_ptr->grams;
      }
     while (recipe_root.next != NULL && ! label) delete_recipe_food(1);
     if (label) servings = 1;
     while (servings <= 0)
      {
      header("NUT:  Add a Recipe");
      new_recipe_show();
      printf("\nHow many servings does this recipe make?  ");
      get_string(key,60);
      servings = atof(key);
      if (servings <= 0) continue;
      header("NUT:  Add a Recipe");
      new_recipe_show();
      printf("\nIs \"%-s\" the correct number of servings for this recipe?  (y/n)  ",key);
      junk = get_char();
      if (junk == 'N' || junk == 'n') servings = 0; 
      }
     for (c = 0; c < NUTRIENT_COUNT; c++) food_work.nutrient[c] /= servings; 
     food_work.grams /= servings;
     new_recipe_show();
     printf("\nPlease enter description of serving size:  ");
     get_string(food_work.serving,50); 
     if (! label)
      {
      new_recipe_show();
      printf("\nWould you like to change weight of serving?  (y/n):  ");
      junk = get_char();
      if (junk == 'y' || junk == 'Y')
       {
       savegrams = food_work.grams;
       savewater = food_work.nutrient[WATER];
       junk = 'n';
       while (junk == 'n' || junk == 'N')
        {
        food_work.grams = savegrams;
        food_work.nutrient[WATER] = savewater;
        new_recipe_show();
        printf("\nType new weight of serving {xxxg for grams, xxxo for oz}:  ");
        get_recipe_qty(&food_work.grams);
        food_work.nutrient[WATER] -= savegrams - food_work.grams;
        new_recipe_show();
        printf("\nIs weight now correct?  (y/n):  ");
        junk = get_char();
        }
       }
      }
     if ((new_food = malloc(sizeof(struct food))) == NULL)
      {
      printf("We are out of memory.  Bummer.\n");
      abort();
      } 
     for (c = 0; c < NUTRIENT_COUNT; c++) food_work.nutrient[c] /= (food_work.grams / 100); 
     memcpy(new_food,&food_work,sizeof(struct food));
     for (c = 0; c < NUTRIENT_COUNT; c++) food_work.nutrient[c] *= (food_work.grams / 100); 
     new_food->ndb_no = options.next_recipe++;
     write_options_db();
     reindex_meals(modify_food_index(order_new_food(),new_food));
     write_meal_db();
     write_theusual_db();
     write_food_db();
     write_recipe(new_food);
     new_recipe_show();
     printf("\nRecipe saved in food database.  Press <enter> to continue...  ");
     junk = get_int();
     food_work.name[0] = '\0';
     food_work.serving[0] = '\0';
     return;
     }
    }
   }
  delfood = atoi(key);
  if (strcmp(key,"") == 0 || delfood == 0) break;
  delete_recipe_food(delfood);
  strcpy(key,"");
  }
 ratio = -383838;
 while (ratio == -383838)
  {
  key_put(key);
  if (! label) food_ptr = food_choice("NUT:  Add a Recipe", 0);
  if (  label) food_ptr = food_choice("NUT:  Add a Labeled Food", 0);
  if (food_ptr == (struct food *) -1) return;
  if (food_ptr == (struct food *)  0) key_clean();
  if (food_ptr == (struct food *)  0) continue;
  if (! label) header("NUT:  Add a Recipe");
  if (  label) header("NUT:  Add a Labeled Food");
  food_show(food_ptr, &one);
  if (! label) get_qty(&ratio, &(food_ptr->grams),&(food_ptr->nutrient[ENERC_KCAL]));
  if (  label) get_select(&ratio);
  if (ratio == -383838)
   {
   key_take();
   strcpy(key,key_take());
   }
  }
 if (ratio == 0)
  {
  key_clean();
  strcpy(key,"");
  }
 if (ratio != -383838)
  {
  key_clean();
  strcpy(key,"");
  if ((new_recipe = malloc(sizeof(struct food))) == NULL)
   {
   printf("We are out of memory.  Bummer.\n");
   abort();
   } 
  memcpy(new_recipe,food_ptr,sizeof(struct food));
  new_recipe->grams *= ratio;
  order_new_recipe();
  }
 }
}

void new_recipe_show()
{
header("NUT:  Add a Recipe");
printf("%-60s   Grams:  %7.2f\n",food_work.name,food_work.grams);
printf("Serving:  %-50s   Ounces: %7.2f\n",food_work.serving,food_work.grams / 28.35);
printf("          %-50s   Water:   %6.2f%%\n"," ",100 * food_work.nutrient[WATER] / food_work.grams);
printf("Percentages of \"Daily Values\" in this serving:                 Refuse:  %3d%%\n\n",food_work.refuse);
food_display(stdout);
spacer(21);
}

void get_recipe_qty(float *result)
{
char buff[128];
fgets(buff,128,stdin);
if (strchr(buff,'g') != NULL) *result = (float) atof(buff);
else if (strchr(buff,'o') != NULL) *result = (float) atof(buff) * 28.35;
else *result = ((float) 0);
}

int recipe_show(int trace)
{
struct food *recipe_ptr = &recipe_root;
int count = 0;
printf("Recipe Name:  %-s\n\n",food_work.name);
while (recipe_ptr->next != NULL)
 {
 recipe_ptr = recipe_ptr->next;
 count++;
 if (options.grams && ! trace) printf("%2d. %-60s    %9.1f g\n",count,recipe_ptr->name,recipe_ptr->grams);
 if (options.grams && trace && recipe_ptr->grams >  0) printf("%2d. %-60s    %9.2f g\n",count,recipe_ptr->name,recipe_ptr->grams);
 if (options.grams && trace && recipe_ptr->grams == 0) printf("%2d. %-60s      %9s\n",count,recipe_ptr->name,"trace");
 if (!options.grams) printf("%2d. %-60s    %8.1f oz\n",count,recipe_ptr->name,recipe_ptr->grams/28.35);
 }
if (count == 0) 
 {
 printf("\n\n\nNo foods have yet been recorded for this recipe.\n");
 spacer(6);
 return 0;
 } 
spacer(count + 2);
return 1;
}

void add_labels()
{
int i;
for (i = 0; i < NUTRIENT_COUNT; i++) food_work.nutrient[i] = -1;
header("NUT:  Add a Labeled Food");
printf("\n\n    Now enter the information from the nutrition statement on the package.");
printf("\n    There will be another opportunity later to review and correct the");
printf("\n    nutrient values after the recipe is determined, so wait until then");
printf("\n    to add vitamins and minerals if the food is heavily fortified and");
printf("\n    the individual vitamins are not part of the food ingredients.");
printf("\n\n    If you enter nutrients as a percentage of the Daily Value, this is");
printf("\n    the standard USA Daily Value for 2000-calorie diets, and not any");
printf("\n    customized values you may have set.");
printf("\n\n    Each time you quit from a nutrient screen, you will be able to select");
printf("\n    another group of nutrients to add.  Leave blank all the nutrients you");
printf("\n    don't find on the nutrition statement.");
spacer(14);
printf("\nPress <enter> to continue...");
i = get_int();
screen_subvert_label();
for ( ; ; )
 {
 header("NUT:  Add a Labeled Food");
 printf("\n\n    Now enter the serving size in grams.  If the food is liquid and measured");
 printf("\n    by volume, use the approximation 1 mL = 1 gram (1 liter = 1000 grams)");
 printf("\n    and 1 fluid ounce = 30 grams (1 quart = 960 grams).");
 spacer(4);
 printf("\nEnter weight of serving in grams:  ");
 get_nut_value(&food_work.grams);
 if (food_work.grams > 0) break;
 }
guess_recipe();
printf("\nDo you want to again edit the nutrient values (y/n)?  ");
i = get_char();
if (i != 'N' && i != 'n') screen_subvert_label();
for (i = 0; i < NUTRIENT_COUNT; i++) if (food_work.nutrient[i] == -1) food_work.nutrient[i] = 0;
}

void screen_subvert_label()
{
int screen_choice, savescreen;
char yn;
savescreen = options.screen;
options.screen = 1;
set_nut_table();
for ( ; ; )
 {
 yn = '\0';
 header("NUT:  Add a Labeled Food");
 printf("\n      Change group of nutrients to view?\n\n");
 printf("\n                    1  --  Daily Value Percentages\n\n");
 printf("                    2  --  Daily Value Absolute Amounts\n\n");
 printf("                    3  --  Carbohydrates and Amino Acids\n\n");
 printf("                    4  --  Miscellaneous Nutrients\n\n");
 printf("                    5  --  Saturated Fatty Acids\n\n");
 printf("                    6  --  Unsaturated Fatty Acids\n\n");
 spacer(16);
 printf("\nEnter your choice (just <enter> to quit):  ");
 screen_choice = get_int();
 if (screen_choice < 1 || screen_choice > 6)
  {
  while (yn != 'Y' && yn != 'y' && yn != 'N' && yn != 'n')
   {
   header("NUT:  Add a Labeled Food");
   spacer(-1);
   printf("Do you want to further edit the nutrient values (y/n)?  ");
   yn = get_char();
   if (yn == 'N' || yn == 'n') 
    {
    options.screen = savescreen;
    return;
    }
   if (yn == 'Y' || yn == 'y') break;
   }
  }
 if (yn == 'Y' || yn == 'y') continue;
 options.screen = screen_choice - 1;
 set_nut_table();
 }
}

void set_nut_table()
{
float tempfloat;
int nutnum;
for ( ; ; )
 {
 header("NUT:  Add a Labeled Food");
 label_nut_list(-1);
 spacer(19);
 printf("\nType number of nutrient to set (or <enter> to quit):  ");
 nutnum = get_int();
 if (nutnum < 1 || nutnum > *ScreenMap[options.screen]) return;
 nutnum = ScreenMap[options.screen][nutnum];

 header("NUT:  Add a Labeled Food");
 label_nut_list(nutnum);
 spacer(19);
 printf("\nEnter value for %s or <enter> to blank value:  ",Nutrient[nutnum]);
 get_nut_value(&tempfloat);
 if (options.screen == 0 && (nutnum != FAMS && nutnum != FAPU && nutnum != OMEGA6 && nutnum != LA && nutnum != AA && nutnum != OMEGA3 && nutnum != ALA && nutnum != EPA && nutnum != DHA)) tempfloat = tempfloat / 100 * DVBase[nutnum];
 food_work.nutrient[nutnum] = tempfloat;
 }
}

void label_nut_list(int selection)
{
int count;
int intdiv = *ScreenMap[options.screen] / 2 + (*ScreenMap[options.screen] % 2 == 0 ? 0 : 1);
for ( count = 0 ; count <= *ScreenMap[options.screen] / 2 - (*ScreenMap[options.screen] % 2 == 0 ? 1 : 0); count++)
 {
 if (options.screen == 0)
  {
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] >= 0 && ScreenMap[options.screen][count+1] != FAMS && ScreenMap[options.screen][count+1] != FAPU && ScreenMap[options.screen][count+1] != OMEGA6 && ScreenMap[options.screen][count+1] != LA && ScreenMap[options.screen][count+1] != AA && ScreenMap[options.screen][count+1] != OMEGA3 && ScreenMap[options.screen][count+1] != ALA && ScreenMap[options.screen][count+1] != EPA && ScreenMap[options.screen][count+1] != DHA) printf("     %2d%s %-14s%7.0f%% DV   ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],food_work.nutrient[ScreenMap[options.screen][count+1]]/DVBase[ScreenMap[options.screen][count+1]]*100);
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] <  0 && ScreenMap[options.screen][count+1] != FAMS && ScreenMap[options.screen][count+1] != FAPU && ScreenMap[options.screen][count+1] != OMEGA6 && ScreenMap[options.screen][count+1] != LA && ScreenMap[options.screen][count+1] != AA && ScreenMap[options.screen][count+1] != OMEGA3 && ScreenMap[options.screen][count+1] != ALA && ScreenMap[options.screen][count+1] != EPA && ScreenMap[options.screen][count+1] != DHA) printf("     %2d%s %-14s%7s%% DV   ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],"       ");
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] >= 0 && (ScreenMap[options.screen][count+1] == FAMS || ScreenMap[options.screen][count+1] == FAPU || ScreenMap[options.screen][count+1] == OMEGA6 || ScreenMap[options.screen][count+1] == LA || ScreenMap[options.screen][count+1] == AA || ScreenMap[options.screen][count+1] == OMEGA3 || ScreenMap[options.screen][count+1] == ALA || ScreenMap[options.screen][count+1] == EPA || ScreenMap[options.screen][count+1] == DHA)) printf("     %2d%s %-14s %7.2f %-3s  ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],food_work.nutrient[ScreenMap[options.screen][count+1]],Unit[ScreenMap[options.screen][count+1]]);
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] <  0 && (ScreenMap[options.screen][count+1] == FAMS || ScreenMap[options.screen][count+1] == FAPU || ScreenMap[options.screen][count+1] == OMEGA6 || ScreenMap[options.screen][count+1] == LA || ScreenMap[options.screen][count+1] == AA || ScreenMap[options.screen][count+1] == OMEGA3 || ScreenMap[options.screen][count+1] == ALA || ScreenMap[options.screen][count+1] == EPA || ScreenMap[options.screen][count+1] == DHA)) printf("     %2d%s %-14s %7s %-3s  ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],"       ",Unit[ScreenMap[options.screen][count+1]]);
  if (count+intdiv < *ScreenMap[options.screen] && food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]] >= 0) printf("    %2d%s %-14s%7.0f%% DV\n",count+1+intdiv,ScreenMap[options.screen][count+1+intdiv]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1+intdiv]],food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]]/DVBase[ScreenMap[options.screen][count+1+intdiv]]*100);
  if (count+intdiv < *ScreenMap[options.screen] && food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]] <  0) printf("    %2d%s %-14s%7s%% DV\n",count+1+intdiv,ScreenMap[options.screen][count+1+intdiv]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1+intdiv]],"       ");
  }
 else
  {
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] >= 0) printf("     %2d%s %-14s %7.2f %-3s  ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],food_work.nutrient[ScreenMap[options.screen][count+1]],Unit[ScreenMap[options.screen][count+1]]);
  if (food_work.nutrient[ScreenMap[options.screen][count+1]] <  0) printf("     %2d%s %-14s %7s %-3s  ",count+1,ScreenMap[options.screen][count+1]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1]],"       ",Unit[ScreenMap[options.screen][count+1]]);
  if (count+intdiv < *ScreenMap[options.screen] && food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]] >= 0) printf("    %2d%s %-14s %7.2f %-3s    \n",count+1+intdiv,ScreenMap[options.screen][count+1+intdiv]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1+intdiv]],food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]],Unit[ScreenMap[options.screen][count+1+intdiv]]);
  if (count+intdiv < *ScreenMap[options.screen] && food_work.nutrient[ScreenMap[options.screen][count+1+intdiv]] <  0) printf("    %2d%s %-14s %7s %-3s    \n",count+1+intdiv,ScreenMap[options.screen][count+1+intdiv]==selection ? "*" : ".",Nutrient[ScreenMap[options.screen][count+1+intdiv]],"       ",Unit[ScreenMap[options.screen][count+1+intdiv]]);
  }
 if (count+intdiv >= *ScreenMap[options.screen]) printf("\n");
 }
spacer(count+1);
}

void get_nut_value(float *dest)
{
char buff[128];
fgets(buff,128,stdin);
if (strcmp(buff,"\n") == 0) *dest = -1;
else *dest = (atof(buff));
}

void guess_recipe()
{
struct food *recipe_ptr = &recipe_root, *magnitude_ptr = &recipe_root;
float recipe_so_far[NUTRIENT_COUNT], recipe_so_far_grams, abacus[NUTRIENT_COUNT], criteria[NUTRIENT_COUNT];
int resolution1 = 1000, resolution2 = 200, savegramoption, abacusindex[NUTRIENT_COUNT];
float step1, step2;
int i, count, foodcount, foodstep, factorstepmajint, factorstepminint;
float factorstep = 0, gramsremaining, thisqty = 0, saveqty, max, min, diff, variance, totalvariance = 0, minvariance, bestqty, max_by_virtue_of_order;
#ifdef DOS
header("");
spacer(-2);
#endif
header("Searching for best recipe...");
count = -1;
for (i = 0; i < NUTRIENT_COUNT; i++)
 {
 if ( food_work.nutrient[i] >= 0)
  {
  count++;
  criteria[count] = food_work.nutrient[i];
  recipe_so_far[count] = 0;
  abacusindex[count] = i;
  }
 } 
recipe_so_far_grams = 0;
bestqty = food_work.grams;
while (magnitude_ptr->next->next != NULL)
 {
 foodcount = 0;
 recipe_ptr = magnitude_ptr;
 while (recipe_ptr->next != NULL)
  {
  recipe_ptr = recipe_ptr->next;
  recipe_ptr->grams = 0;
  foodcount++;
  }
 minvariance = 3.40282347e+38;
 max_by_virtue_of_order = bestqty;
 bestqty = 0;
 saveqty = 0;
 for (factorstepminint = resolution2; factorstepminint >= 0; factorstepminint--)
  {
  for (factorstepmajint = resolution1; factorstepmajint >= 0; factorstepmajint--)
   {
   step1 = (float) 1 / resolution1;
   step2 = (float) 1 / resolution2;
   for (i = 0; i <= count; i++) abacus[i] = recipe_so_far[i];
   gramsremaining = food_work.grams - recipe_so_far_grams;
   recipe_ptr = magnitude_ptr;
   for (foodstep = 0; foodstep < foodcount; foodstep++)
    {
    if (foodstep == 0) factorstep = (float) factorstepmajint * step1;
    else factorstep = (float) factorstepminint * step2;
    if (foodstep == 1 && foodcount == 2) factorstepminint = 0;
    totalvariance = 0;
    recipe_ptr = recipe_ptr->next;
    max = gramsremaining < max_by_virtue_of_order ? gramsremaining : max_by_virtue_of_order;
    min = gramsremaining / (foodcount - foodstep);
    thisqty = min + ((max - min) * factorstep);
    if (foodstep == 0) saveqty = thisqty;
    gramsremaining -= thisqty;
    for (i = 0; i <= count; i++) abacus[i] += recipe_ptr->nutrient[abacusindex[i]] * thisqty / 100;
    for (i = 0; i <= count; i++)
     {
     diff = criteria[i] - abacus[i];
     variance = diff * diff;
     totalvariance += variance;
     }
    }
   if (totalvariance < minvariance)
    {
    minvariance = totalvariance;
    bestqty = saveqty;
    }
   }
  }
 magnitude_ptr = magnitude_ptr->next;
 magnitude_ptr->grams = bestqty;
 for (i = 0; i <= count; i++) recipe_so_far[i] += magnitude_ptr->nutrient[abacusindex[i]] * magnitude_ptr->grams / 100;
 recipe_so_far_grams += bestqty;
 }
magnitude_ptr->next->grams = food_work.grams - recipe_so_far_grams;
for (i = 0; i <= count; i++) recipe_so_far[i] += magnitude_ptr->nutrient[abacusindex[i]] * magnitude_ptr->grams / 100;
recipe_so_far_grams += magnitude_ptr->grams;
header("NUT:  Add a Labeled Food");
savegramoption = options.grams;
options.grams = 1;
recipe_show(1);
options.grams = savegramoption;
recipe_ptr = &recipe_root;
clear_work();
while (recipe_ptr->next != NULL)
 {
 recipe_ptr = recipe_ptr->next;
 for (i = 0; i < NUTRIENT_COUNT; i++) food_work.nutrient[i] += (recipe_ptr->nutrient[i] * recipe_ptr->grams / 100);                                           
 food_work.grams += recipe_ptr->grams;
 }
while (recipe_root.next != NULL) delete_recipe_food(1);
for (i = 0; i <= count; i++) food_work.nutrient[abacusindex[i]] = criteria[i];
}
