/* options.h */

/*
    NUT nutrition software 
    Copyright (C) 2004 Jim Jozwiak.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef OPTIONS_H
#define OPTIONS_H

#include "food.h"
#include "meal.h"

struct opt
 {
 int delopt;
 int defanal;
 int screen;
 int custom;
 float pcprotein;
 float pccarb;
 float pcsatfat;
 float fatprotratio;
 int next_recipe;
 int locknuts[NUTRIENT_COUNT];
 float abnuts[NUTRIENT_COUNT];
 int mealsperday;
 char grams;
 struct meal *temp_meal_root;
 };

extern struct opt options;
extern int mealdb_mealsperday;

void initialize_options(void);
void personal_cal(void);
void efa_method(void);
void protein_percent(void);
void fatprot_ratio(void);
void carb_percent(void);
void satfat_percent(void);
void protein_absolute(void);
void carb_absolute(void);
void fiber_absolute(void);
void auto_cal(float *, int);
void auto_del(void);
void screen(void);
void get_cals(float *);
void new_nut_levels(void);
void restore_defaults(int);
void efa_dynamics(int);

#endif
